HTMLElement.prototype.appendHTML = function(html) {
    var divTemp = document.createElement("div"), nodes = null , fragment = document.createDocumentFragment();
    divTemp.innerHTML = html;
    nodes = divTemp.childNodes;
    for (var i=0, length=nodes.length; i<length; i+=1) {
       fragment.appendChild(nodes[i].cloneNode(true));
    }
    this.appendChild(fragment);
    nodes = null;
    fragment = null;
};

var $= function(s){
     return document.querySelector(s)
}

var hasClass= function(ele,cls){
    return ele.className.match(new RegExp('(\\s|^)'+cls+'(\\s|$)'));
}

var addClass= function(ele,cls){
     if (!hasClass(ele,cls)) ele.className += " "+cls;
}

var removeClass= function(ele,cls){
if (hasClass(ele,cls)) {
	    var reg = new RegExp('(\\s|^)'+cls+'(\\s|$)');ele.className=ele.className.replace(reg,' ');
	}
}

function insertAudio(streamUrl){
	document.body.appendHTML(
	'<div id="audio_player_wrap">'+
	'<div class="audio_player">'+
	'	   <div class="play_btn"></div>'+
		'		<div class="play_panel_wrap">'+
	'		<div class="play_panel">'+
	'			<div class="progress">'+
	'				<span class="time_cur"></span>'+
	'				<span class="total">'+
	'					 <span class="current"></span>'+
	'				</span>'+
	'				<span class="time_end"></span>'+
	'			</div>'+
	'		</div>'+
	'</div>'+
	'</div>'+
	'</div>');

    var audio_player= $(".audio_player");
	var playBtn=  $(".audio_player .play_btn");
	var curLabel = $(".audio_player .time_cur");
	var endLabel = $(".audio_player .time_end");
	var curBar=  $(".audio_player .current");

	var player = new Audio(streamUrl);
	player.preload = "metadata";
	player.loop = false;
	player.autoplay = false;

	function toggle(){
	   if(player.paused){
		    player.play();
			addClass(audio_player,"ing");
		}else{
		    player.pause();
			removeClass(audio_player,"ing");
		}
	}

	function format(num){
        var m= parseInt(num / 60);
		var s= parseInt(num % 60);
		m = m < 10 ? "0"+m : m;
		s = s <10 ? "0"+s : s;
		return m+":"+s;
   }

   function _timeupdate(){
		curLabel.innerHTML=format(this.currentTime);
		curBar.style.width= this.currentTime/ this.duration*100+"%";
	}

   playBtn.addEventListener("click",toggle);
   player.addEventListener("canplay",function(){
	   curLabel.innerHTML= "00:00";
       endLabel.innerHTML= format( this.duration)
   });
   player.addEventListener("loadedmetadata",function(){
	   curLabel.innerHTML= "00:00";
       endLabel.innerHTML= format( this.duration)
   });
   player.addEventListener("loadeddata",function(){
	   curLabel.innerHTML= "00:00";
       endLabel.innerHTML= format( this.duration)
   });
   player.addEventListener("timeupdate",_timeupdate);

}